import { __read, __spread, __values } from "tslib";
var UrlVariableExtension = /** @class */ (function () {
    function UrlVariableExtension(storage, prefix, priority) {
        this.store = storage;
        this.prefix = prefix;
        this.priority = priority;
    }
    UrlVariableExtension.prototype.getPriority = function () {
        return this.priority;
    };
    UrlVariableExtension.prototype.enable = function (path) {
        var e_1, _a;
        try {
            for (var _b = __values(Object.entries(this.getQueryStringVariables(path))), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), variable = _d[0], value = _d[1];
                this.store.setVariable(variable, value);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    UrlVariableExtension.prototype.getVariables = function () {
        var e_2, _a;
        var variables = {};
        var _loop_1 = function (variable, value) {
            if (value !== undefined) {
                variables[variable] = function () { return Promise.resolve(value); };
            }
        };
        try {
            for (var _b = __values(Object.entries(this.store.getVariables())), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), variable = _d[0], value = _d[1];
                _loop_1(variable, value);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return variables;
    };
    UrlVariableExtension.prototype.getQueryStringVariables = function (path) {
        var _this = this;
        var url = new URL(path, 'https://host');
        var variables = {};
        url.searchParams.forEach(function (value, parameter) {
            var _a;
            if (!parameter.startsWith(_this.prefix)) {
                return;
            }
            var variable = parameter.substring(_this.prefix.length);
            var currentValue;
            try {
                currentValue = JSON.parse(value);
            }
            catch (_b) {
                currentValue = value;
            }
            if (variable.endsWith('[]')) {
                variable = variable.substring(0, variable.length - '[]'.length);
                currentValue = __spread(((_a = variables[variable]) !== null && _a !== void 0 ? _a : []), [currentValue]);
            }
            variables[variable] = currentValue;
        });
        return variables;
    };
    return UrlVariableExtension;
}());
export default UrlVariableExtension;
