import engine from '@croct/plug-rule-engine/plugin';
import UrlVariablesExtension from './extension';
import { LocalStore, PageStore } from './store';
import { optionsSchema } from './schemas';
engine.extend('urlVariables', function (_a) {
    var _b, _c;
    var options = _a.options, sdk = _a.sdk;
    optionsSchema.validate(options);
    return new UrlVariablesExtension((function () {
        switch (options.persistence) {
            case 'page':
                return new PageStore();
            case 'browser':
                return new LocalStore(sdk.getBrowserStorage());
            default:
            case 'tab':
                return new LocalStore(sdk.getTabStorage());
        }
    })(), (_b = options.prefix) !== null && _b !== void 0 ? _b : 'ct-', (_c = options.priority) !== null && _c !== void 0 ? _c : 256);
});
