var PageStore = /** @class */ (function () {
    function PageStore() {
        this.storage = {};
    }
    PageStore.prototype.getVariables = function () {
        return this.storage;
    };
    PageStore.prototype.setVariable = function (name, value) {
        this.storage[name] = value;
    };
    return PageStore;
}());
export { PageStore };
var LocalStore = /** @class */ (function () {
    function LocalStore(storage) {
        this.storage = storage;
    }
    LocalStore.prototype.getVariables = function () {
        var variables = {};
        for (var index = 0; index < this.storage.length; index++) {
            var key = this.storage.key(index);
            var value = this.getVariable(key);
            if (value !== undefined) {
                variables[key] = value;
            }
        }
        return variables;
    };
    LocalStore.prototype.getVariable = function (name) {
        var json = this.storage.getItem(name);
        if (json !== null) {
            try {
                return JSON.parse(json);
            }
            catch (_a) {
                // suppress
            }
        }
        return undefined;
    };
    LocalStore.prototype.setVariable = function (name, value) {
        this.storage.setItem(name, JSON.stringify(value));
    };
    return LocalStore;
}());
export { LocalStore };
